{================== urav234.pas ===========================================
  襭 ࠢ 2, 3, 4 ⥯.
==========================================================================}
program URAV234;

uses crt;

label L20, L30, L40, jdite, para2, konec;

var
   N :integer;
   L,XX,T :array[1..4] of real;
   A,B,C,D,E,G,H,J,M,P,Q,R,S,TT,X,Y,Z :real;
   K :char;

{-------------------------------------------------------------------------}
function arccos(XX:real) :real;
begin
     arccos:=1.5707963-arctan(XX/sqrt(1-sqr(XX)))
end;
{-------------------------------------------------------------------------}
function sgn(XX:real) :real;
begin
     if XX<0 then sgn:=-1;
     if XX>=0 then sgn:=1;
end;
{-------------------------------------------------------------------------}
procedure STEPEN2;
begin
     G:=sqr(L[1])-L[2];
     if G>=0 then begin
        XX[1]:=-L[1]+sqrt(G);
        XX[2]:=-L[1]-sqrt(G);
        exit;
     end;
     XX[1]:=-L[1];
     XX[2]:=sqrt(-G);
end;
{-------------------------------------------------------------------------}
procedure STEPEN3;
var
   P,Q,R,F,U,V :real;
begin
     P:=L[2]/3-sqr(L[1]);
     Q:=L[1]*L[1]*L[1]-L[1]*L[2]/2+L[3]/2;
     G:=P*P*P+Q*Q;
     if G<=0 then begin
        R:=sgn(Q)*sqrt(-P);
        F:=arccos(Q/R/R/R)/3;
        XX[1]:=-2*R*cos(F)-L[1];
        XX[2]:=-2*R*cos(F+2.094395)-L[1];
        XX[3]:=-2*R*cos(F-2.094395)-L[1];
        exit;
     end;
     U:=-Q+sqrt(G);
     U:=sgn(U)*exp(ln(abs(U))/3);
     V:=-Q-sqrt(G);
     V:=sgn(V)*exp(ln(abs(V))/3);
     XX[1]:=U+V-L[1];
     XX[2]:=-(U+V)/2-L[1];
     XX[3]:=(U-V)*sqrt(3)/2;
end;

{=========================================================================}

begin
     write(' c⥯ (2,3,4): ');
     readln (N);
     if N=2 then goto L20;
     if N=3 then goto L30;
     if N=4 then goto L40;
konec:
     halt;
jdite:
     K:=readkey;
     goto konec;

{-------------------------------------------------------------------------}
L20:
    write('A=');read(A);write('B=');read(B);write('C=');read(C);
    if A=0 then goto konec;
    L[1]:=B/2/A;
    L[2]:=C/A;
    STEPEN2;
    if G>=0 then begin
       TT:=((A*XX[1]+B)*XX[1]+C)/C;
       writeln('X1 = ',XX[1],'  . 譮 ',TT);
       TT:=((A*XX[2]+B)*XX[2]+C)/C;
       writeln('X2 = ',XX[2],'  . 譮 ',TT);
       goto jdite;
    end;
    R:=(A*(sqr(XX[1])-sqr(XX[2]))+B*XX[1]+C)/C;
    J:=(2*A*XX[1]+B)/B;
    writeln('X1 = ',XX[1],' +',XX[2],'i');
    writeln('X2 = ',XX[1],' -',XX[2],'i');
    writeln(' . 譮 ',R,' + ',J,'i');
    goto jdite;
{-------------------------------------------------------------------------}
L30:
    write('A=');read(A);write('B=');read(B);
    write('C=');read(C);write('D=');read(D);
    if A=0 then goto konec;
    if D=0 then goto konec;
    L[1]:=B/3/A;
    L[2]:=C/A;
    L[3]:=D/A;
    STEPEN3;
    TT:=(((A*XX[1]+B)*XX[1]+C)*XX[1]+D)/D;
    writeln('X1 = ',XX[1],'  . 譮 ',TT);
    if G<=0 then begin
       TT:=(((A*XX[2]+B)*XX[2]+C)*XX[2]+D)/D;
       writeln('X2 = ',XX[2],'  . 譮 ',TT);
       TT:=(((A*XX[3]+B)*XX[3]+C)*XX[3]+D)/D;
       writeln('X3 = ',XX[3],'  . 譮 ',TT);
       goto jdite;
    end;
    R:=(A*(XX[2]*XX[2]*XX[2]-3*XX[2]*sqr(XX[3]))+B*(sqr(XX[2])-sqr(XX[3]))+C*XX[2]+D)/D;
    J:=(A*(3*sqr(XX[2])-sqr(XX[3]))+2*B*XX[2]+C)/C;
    writeln('X2 = ',XX[2],' +',XX[3],'i');
    writeln('X3 = ',XX[2],' -',XX[3],'i');
    writeln(' . 譮 ',R,' + ',J,'i');
    goto jdite;
{-------------------------------------------------------------------------}
L40:
    write('A=');read(A);write('B=');read(B);
    write('C=');read(C);write('D=');read(D);write('E=');read(E);
    if A=0 then goto konec;
    if E=0 then goto konec;
    T[1]:=B/A;
    T[2]:=C/A;
    T[3]:=D/A;
    T[4]:=E/A;
    P:=T[1]*T[3]-4*T[4];
    Q:=4*T[2]*T[4]-sqr(T[1])*T[4]-sqr(T[3]);
    L[1]:=-T[2]/3;
    L[2]:=P;
    L[3]:=Q;
    STEPEN3;
    if G<=0 then begin
       if XX[1]<XX[2] then XX[1]:=XX[2];
       if XX[1]<XX[3] then XX[1]:=XX[3];
    end;
    Z:=XX[1];
    S:=sqrt(sqr(T[1])-4*T[2]+4*Z)/2;
    H:=T[1]*Z/2-T[3];
    M:=sgn(H)*sqrt(Z*Z-4*T[4])/2;
    L[1]:=T[1]/4+S/2;
    L[2]:=Z/2+M;
    STEPEN2;
    if G>=0 then begin
       TT:=((((A*XX[1]+B)*XX[1]+C)*XX[1]+D)*XX[1]+E)/E;
       writeln('X1 = ',XX[1],'  . 譮 ',TT);
       TT:=((((A*XX[2]+B)*XX[2]+C)*XX[2]+D)*XX[2]+E)/E;
       writeln('X2 = ',XX[2],'  . 譮 ',TT);
       goto para2;
    end;
    X:=XX[1];
    Y:=XX[2];
    R:=(A*(X*X*X*X-6*X*X*Y*Y+Y*Y*Y*Y)+B*(X*X*X-3*X*Y*Y)+C*(X*X-Y*Y)+D*X+E)/E;
    J:=(4*A*(X*X*X-X*Y*Y)+B*(3*X*X-Y*Y)+2*C*X+D)/D;
    writeln('X1 = ',X,' +',Y,'i');
    writeln('X2 = ',X,' -',Y,'i');
    writeln(' . 譮 ',R,' + ',J,'i');
para2:
    L[1]:=T[1]/4-S/2;
    L[2]:=Z/2-M;
    STEPEN2;
    if G>=0 then begin
       TT:=((((A*XX[1]+B)*XX[1]+C)*XX[1]+D)*XX[1]+E)/E;
       writeln('X3 = ',XX[1],'  . 譮 ',TT);
       TT:=((((A*XX[2]+B)*XX[2]+C)*XX[2]+D)*XX[2]+E)/E;
       writeln('X4 = ',XX[2],'  . 譮 ',TT);
       goto jdite;
    end;
    X:=XX[1];
    Y:=XX[2];
    R:=(A*(X*X*X*X-6*X*X*Y*Y+Y*Y*Y*Y)+B*(X*X*X-3*X*Y*Y)+C*(X*X-Y*Y)+D*X+E)/E;
    J:=(4*A*(X*X*X-X*Y*Y)+B*(3*X*X-Y*Y)+2*C*X+D)/D;
    writeln('X3 = ',X,' +',Y,'i');
    writeln('X4 = ',X,' -',Y,'i');
    writeln(' . 譮 ',R,' + ',J,'i');
    goto jdite;
end.
{=========================================================================}
